#include <time.h>
#include <stdint.h>

typedef uint64_t hp_timing_t;

#define HP_TIMING_NOW(var) \
  __asm__ __volatile__ ("isb; mrs %0, cntvct_el0" : "=r" (var))

/* Compute elapsed time in nanoseconds.  */
#undef HP_TIMING_DIFF
#define HP_TIMING_DIFF(Diff, Start, End)			\
({  hp_timing_t freq;						\
    __asm__ __volatile__ ("mrs %0, cntfrq_el0" : "=r" (freq));	\
   (Diff) = ((End) - (Start)) * (UINT64_C(1000000000) / freq);	\
})


/* Accumulate ADD into SUM.  No attempt is made to be thread-safe.  */
#define HP_TIMING_ACCUM_NT(Sum, Diff)		((Sum) += (Diff))

#define HP_TIMING_PRINT_SIZE (3 * sizeof (hp_timing_t) + 1)

/* Write a decimal representation of the timing value into the given string.  */
#define HP_TIMING_PRINT(Dest, Len, Val) 				\
  do {									\
    char __buf[HP_TIMING_PRINT_SIZE];					\
    char *__dest = (Dest);						\
    size_t __len = (Len);						\
    char *__cp = _itoa ((Val), __buf + sizeof (__buf), 10, 0);		\
    size_t __cp_len = MIN (__buf + sizeof (__buf) - __cp, __len);	\
    memcpy (__dest, __cp, __cp_len);					\
    __dest[__cp_len - 1] = '\0';					\
  } while (0)
